/* Main Simulation File */

#if defined(__cplusplus)
extern "C" {
#endif

#include "FmuExportCrossCompile_model.h"
#include "simulation/solver/events.h"



/* dummy VARINFO and FILEINFO */
const VAR_INFO dummyVAR_INFO = omc_dummyVarInfo;

int FmuExportCrossCompile_input_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_input_function_init(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_input_function_updateStartValues(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_inputNames(DATA *data, char ** names){
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_data_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_dataReconciliationInputNames(DATA *data, char ** names){
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_dataReconciliationUnmeasuredVariables(DATA *data, char ** names)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_output_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_setc_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_setb_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}


/*
equation index: 8
type: SIMPLE_ASSIGN
$whenCondition1 = h <= 0.0
*/
void FmuExportCrossCompile_eqFunction_8(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,8};
  modelica_boolean tmp0;
  modelica_real tmp1;
  modelica_real tmp2;
  tmp1 = 1.0;
  tmp2 = 0.0;
  relationhysteresis(data, &tmp0, (data->localData[0]->realVars[0] /* h STATE(1,v) */), 0.0, tmp1, tmp2, 0, LessEq, LessEqZC);
  (data->localData[0]->booleanVars[0] /* $whenCondition1 DISCRETE */) = tmp0;
  TRACE_POP
}
/*
equation index: 9
type: WHEN

when {$whenCondition1} then
  v_new = (-e) * pre(v);
end when;
*/
void FmuExportCrossCompile_eqFunction_9(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,9};
  if(((data->localData[0]->booleanVars[0] /* $whenCondition1 DISCRETE */) && !(data->simulationInfo->booleanVarsPre[0] /* $whenCondition1 DISCRETE */) /* edge */))
  {
    (data->localData[0]->realVars[4] /* v_new DISCRETE */) = ((-(data->simulationInfo->realParameter[0] /* e PARAM */))) * ((data->simulationInfo->realVarsPre[1] /* v STATE(1) */));
  }
  TRACE_POP
}
/*
equation index: 10
type: SIMPLE_ASSIGN
$DER.h = v
*/
void FmuExportCrossCompile_eqFunction_10(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,10};
  (data->localData[0]->realVars[2] /* der(h) STATE_DER */) = (data->localData[0]->realVars[1] /* v STATE(1) */);
  TRACE_POP
}
/*
equation index: 11
type: SIMPLE_ASSIGN
$DER.v = -g
*/
void FmuExportCrossCompile_eqFunction_11(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,11};
  (data->localData[0]->realVars[3] /* der(v) STATE_DER */) = (-(data->simulationInfo->realParameter[1] /* g PARAM */));
  TRACE_POP
}
/*
equation index: 12
type: WHEN

when {$whenCondition1} then
  reinit(v,  v_new);
end when;
*/
void FmuExportCrossCompile_eqFunction_12(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,12};
  if(((data->localData[0]->booleanVars[0] /* $whenCondition1 DISCRETE */) && !(data->simulationInfo->booleanVarsPre[0] /* $whenCondition1 DISCRETE */) /* edge */))
  {
    (data->localData[0]->realVars[1] /* v STATE(1) */) = (data->localData[0]->realVars[4] /* v_new DISCRETE */);
    infoStreamPrint(LOG_EVENTS, 0, "reinit v = %g", (data->localData[0]->realVars[1] /* v STATE(1) */));
    data->simulationInfo->needToIterate = 1;
  }
  TRACE_POP
}

OMC_DISABLE_OPT
int FmuExportCrossCompile_functionDAE(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  int equationIndexes[1] = {0};
#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_DAE);
#endif

  data->simulationInfo->needToIterate = 0;
  data->simulationInfo->discreteCall = 1;
  FmuExportCrossCompile_functionLocalKnownVars(data, threadData);
  FmuExportCrossCompile_eqFunction_8(data, threadData);

  FmuExportCrossCompile_eqFunction_9(data, threadData);

  FmuExportCrossCompile_eqFunction_10(data, threadData);

  FmuExportCrossCompile_eqFunction_11(data, threadData);

  FmuExportCrossCompile_eqFunction_12(data, threadData);
  data->simulationInfo->discreteCall = 0;
  
#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_DAE);
#endif
  TRACE_POP
  return 0;
}


int FmuExportCrossCompile_functionLocalKnownVars(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}


/* forwarded equations */
extern void FmuExportCrossCompile_eqFunction_10(DATA* data, threadData_t *threadData);
extern void FmuExportCrossCompile_eqFunction_11(DATA* data, threadData_t *threadData);

static void functionODE_system0(DATA *data, threadData_t *threadData)
{
  {
    FmuExportCrossCompile_eqFunction_10(data, threadData);
    threadData->lastEquationSolved = 10;
  }
  {
    FmuExportCrossCompile_eqFunction_11(data, threadData);
    threadData->lastEquationSolved = 11;
  }
}

int FmuExportCrossCompile_functionODE(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_FUNCTION_ODE);
#endif

  
  data->simulationInfo->callStatistics.functionODE++;
  
  FmuExportCrossCompile_functionLocalKnownVars(data, threadData);
  functionODE_system0(data, threadData);

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_FUNCTION_ODE);
#endif

  TRACE_POP
  return 0;
}

/* forward the main in the simulation runtime */
extern int _main_SimulationRuntime(int argc, char**argv, DATA *data, threadData_t *threadData);

#include "FmuExportCrossCompile_12jac.h"
#include "FmuExportCrossCompile_13opt.h"

struct OpenModelicaGeneratedFunctionCallbacks FmuExportCrossCompile_callback = {
   NULL,    /* performSimulation */
   NULL,    /* performQSSSimulation */
   NULL,    /* updateContinuousSystem */
   FmuExportCrossCompile_callExternalObjectDestructors,    /* callExternalObjectDestructors */
   NULL,    /* initialNonLinearSystem */
   NULL,    /* initialLinearSystem */
   NULL,    /* initialMixedSystem */
   #if !defined(OMC_NO_STATESELECTION)
   FmuExportCrossCompile_initializeStateSets,
   #else
   NULL,
   #endif    /* initializeStateSets */
   FmuExportCrossCompile_initializeDAEmodeData,
   FmuExportCrossCompile_functionODE,
   FmuExportCrossCompile_functionAlgebraics,
   FmuExportCrossCompile_functionDAE,
   FmuExportCrossCompile_functionLocalKnownVars,
   FmuExportCrossCompile_input_function,
   FmuExportCrossCompile_input_function_init,
   FmuExportCrossCompile_input_function_updateStartValues,
   FmuExportCrossCompile_data_function,
   FmuExportCrossCompile_output_function,
   FmuExportCrossCompile_setc_function,
   FmuExportCrossCompile_setb_function,
   FmuExportCrossCompile_function_storeDelayed,
   FmuExportCrossCompile_function_storeSpatialDistribution,
   FmuExportCrossCompile_function_initSpatialDistribution,
   FmuExportCrossCompile_updateBoundVariableAttributes,
   FmuExportCrossCompile_functionInitialEquations,
   1, /* useHomotopy - 0: local homotopy (equidistant lambda), 1: global homotopy (equidistant lambda), 2: new global homotopy approach (adaptive lambda), 3: new local homotopy approach (adaptive lambda)*/
   NULL,
   FmuExportCrossCompile_functionRemovedInitialEquations,
   FmuExportCrossCompile_updateBoundParameters,
   FmuExportCrossCompile_checkForAsserts,
   FmuExportCrossCompile_function_ZeroCrossingsEquations,
   FmuExportCrossCompile_function_ZeroCrossings,
   FmuExportCrossCompile_function_updateRelations,
   FmuExportCrossCompile_zeroCrossingDescription,
   FmuExportCrossCompile_relationDescription,
   FmuExportCrossCompile_function_initSample,
   FmuExportCrossCompile_INDEX_JAC_A,
   FmuExportCrossCompile_INDEX_JAC_B,
   FmuExportCrossCompile_INDEX_JAC_C,
   FmuExportCrossCompile_INDEX_JAC_D,
   FmuExportCrossCompile_INDEX_JAC_F,
   FmuExportCrossCompile_INDEX_JAC_H,
   FmuExportCrossCompile_initialAnalyticJacobianA,
   FmuExportCrossCompile_initialAnalyticJacobianB,
   FmuExportCrossCompile_initialAnalyticJacobianC,
   FmuExportCrossCompile_initialAnalyticJacobianD,
   FmuExportCrossCompile_initialAnalyticJacobianF,
   FmuExportCrossCompile_initialAnalyticJacobianH,
   FmuExportCrossCompile_functionJacA_column,
   FmuExportCrossCompile_functionJacB_column,
   FmuExportCrossCompile_functionJacC_column,
   FmuExportCrossCompile_functionJacD_column,
   FmuExportCrossCompile_functionJacF_column,
   FmuExportCrossCompile_functionJacH_column,
   FmuExportCrossCompile_linear_model_frame,
   FmuExportCrossCompile_linear_model_datarecovery_frame,
   FmuExportCrossCompile_mayer,
   FmuExportCrossCompile_lagrange,
   FmuExportCrossCompile_pickUpBoundsForInputsInOptimization,
   FmuExportCrossCompile_setInputData,
   FmuExportCrossCompile_getTimeGrid,
   FmuExportCrossCompile_symbolicInlineSystem,
   FmuExportCrossCompile_function_initSynchronous,
   FmuExportCrossCompile_function_updateSynchronous,
   FmuExportCrossCompile_function_equationsSynchronous,
   FmuExportCrossCompile_inputNames,
   FmuExportCrossCompile_dataReconciliationInputNames,
   FmuExportCrossCompile_dataReconciliationUnmeasuredVariables,
   FmuExportCrossCompile_read_simulation_info,
   FmuExportCrossCompile_read_input_fmu,
   NULL,
   NULL,
   -1,
   NULL,
   NULL,
   -1

};

#define _OMC_LIT_RESOURCE_0_name_data "BouncingBall"
#define _OMC_LIT_RESOURCE_0_dir_data "."
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_0_name,12,_OMC_LIT_RESOURCE_0_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_0_dir,1,_OMC_LIT_RESOURCE_0_dir_data);

#define _OMC_LIT_RESOURCE_1_name_data "Complex"
#define _OMC_LIT_RESOURCE_1_dir_data "/var/lib/jenkins1/ws/OpenModelica_maintenance_v1.23/libraries/.openmodelica/libraries/Complex 4.0.0+maint.om"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_1_name,7,_OMC_LIT_RESOURCE_1_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_1_dir,108,_OMC_LIT_RESOURCE_1_dir_data);

#define _OMC_LIT_RESOURCE_2_name_data "FmuExportCrossCompile"
#define _OMC_LIT_RESOURCE_2_dir_data "."
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_2_name,21,_OMC_LIT_RESOURCE_2_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_2_dir,1,_OMC_LIT_RESOURCE_2_dir_data);

#define _OMC_LIT_RESOURCE_3_name_data "Modelica"
#define _OMC_LIT_RESOURCE_3_dir_data "/var/lib/jenkins1/ws/OpenModelica_maintenance_v1.23/libraries/.openmodelica/libraries/Modelica 3.2.3+maint.om"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_3_name,8,_OMC_LIT_RESOURCE_3_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_3_dir,109,_OMC_LIT_RESOURCE_3_dir_data);

#define _OMC_LIT_RESOURCE_4_name_data "ModelicaServices"
#define _OMC_LIT_RESOURCE_4_dir_data "/var/lib/jenkins1/ws/OpenModelica_maintenance_v1.23/libraries/.openmodelica/libraries/ModelicaServices 4.0.0+maint.om"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_4_name,16,_OMC_LIT_RESOURCE_4_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_4_dir,117,_OMC_LIT_RESOURCE_4_dir_data);

#define _OMC_LIT_RESOURCE_5_name_data "RoomHeating_OM"
#define _OMC_LIT_RESOURCE_5_dir_data "/var/lib/jenkins1/ws/OpenModelica_maintenance_v1.23/testsuite/special/FmuExportCrossCompile"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_5_name,14,_OMC_LIT_RESOURCE_5_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_5_dir,91,_OMC_LIT_RESOURCE_5_dir_data);

#define _OMC_LIT_RESOURCE_6_name_data "WaterTank"
#define _OMC_LIT_RESOURCE_6_dir_data "/var/lib/jenkins1/ws/OpenModelica_maintenance_v1.23/testsuite/special/FmuExportCrossCompile"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_6_name,9,_OMC_LIT_RESOURCE_6_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_6_dir,91,_OMC_LIT_RESOURCE_6_dir_data);

static const MMC_DEFSTRUCTLIT(_OMC_LIT_RESOURCES,14,MMC_ARRAY_TAG) {MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_0_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_0_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_1_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_1_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_2_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_2_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_3_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_3_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_4_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_4_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_5_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_5_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_6_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_6_dir)}};
void FmuExportCrossCompile_setupDataStruc(DATA *data, threadData_t *threadData)
{
  assertStreamPrint(threadData,0!=data, "Error while initialize Data");
  threadData->localRoots[LOCAL_ROOT_SIMULATION_DATA] = data;
  data->callback = &FmuExportCrossCompile_callback;
  OpenModelica_updateUriMapping(threadData, MMC_REFSTRUCTLIT(_OMC_LIT_RESOURCES));
  data->modelData->modelName = "FmuExportCrossCompile";
  data->modelData->modelFilePrefix = "FmuExportCrossCompile";
  data->modelData->resultFileName = NULL;
  data->modelData->modelDir = "";
  data->modelData->modelGUID = "{d2ae1f5d-fde7-45d9-b26a-3bc1fb3d9b50}";
  data->modelData->initXMLData = NULL;
  data->modelData->modelDataXml.infoXMLData = NULL;
  GC_asprintf(&data->modelData->modelDataXml.fileName, "%s/FmuExportCrossCompile_info.json", data->modelData->resourcesDir);
  data->modelData->runTestsuite = 0;
  data->modelData->nStates = 2;
  data->modelData->nVariablesReal = 5;
  data->modelData->nDiscreteReal = 1;
  data->modelData->nVariablesInteger = 0;
  data->modelData->nVariablesBoolean = 1;
  data->modelData->nVariablesString = 0;
  data->modelData->nParametersReal = 2;
  data->modelData->nParametersInteger = 0;
  data->modelData->nParametersBoolean = 0;
  data->modelData->nParametersString = 0;
  data->modelData->nInputVars = 0;
  data->modelData->nOutputVars = 0;
  data->modelData->nAliasReal = 0;
  data->modelData->nAliasInteger = 0;
  data->modelData->nAliasBoolean = 0;
  data->modelData->nAliasString = 0;
  data->modelData->nZeroCrossings = 1;
  data->modelData->nSamples = 0;
  data->modelData->nRelations = 1;
  data->modelData->nMathEvents = 0;
  data->modelData->nExtObjs = 0;
  data->modelData->modelDataXml.modelInfoXmlLength = 0;
  data->modelData->modelDataXml.nFunctions = 0;
  data->modelData->modelDataXml.nProfileBlocks = 0;
  data->modelData->modelDataXml.nEquations = 13;
  data->modelData->nMixedSystems = 0;
  data->modelData->nLinearSystems = 0;
  data->modelData->nNonLinearSystems = 0;
  data->modelData->nStateSets = 0;
  data->modelData->nJacobians = 6;
  data->modelData->nOptimizeConstraints = 0;
  data->modelData->nOptimizeFinalConstraints = 0;
  data->modelData->nDelayExpressions = 0;
  data->modelData->nBaseClocks = 0;
  data->modelData->nSpatialDistributions = 0;
  data->modelData->nSensitivityVars = 0;
  data->modelData->nSensitivityParamVars = 0;
  data->modelData->nSetcVars = 0;
  data->modelData->ndataReconVars = 0;
  data->modelData->nSetbVars = 0;
  data->modelData->nRelatedBoundaryConditions = 0;
  data->modelData->linearizationDumpLanguage = OMC_LINEARIZE_DUMP_LANGUAGE_MODELICA;
}

static int rml_execution_failed()
{
  fflush(NULL);
  fprintf(stderr, "Execution failed!\n");
  fflush(NULL);
  return 1;
}

